"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const webpack = require("webpack");
class Dll {
    constructor(dllName, sourceType, tempDir) {
        this.dllName = dllName;
        this.sourceType = sourceType;
        this.metadataPath = path.join(tempDir, dllName + "." + sourceType + "-dll.json");
    }
    produce() {
        return new webpack.DllPlugin({
            context: __dirname,
            name: this.dllName,
            path: this.metadataPath,
        });
    }
    consume() {
        return new webpack.DllReferencePlugin({
            context: __dirname,
            manifest: require(this.metadataPath),
            name: this.sourceType === "umd" ? this.dllName : "./" + this.dllName,
            sourceType: this.sourceType,
        });
    }
}
exports.Dll = Dll;
